#include <stdio.h>
#include <v.h>

/* Tests routines for displaying 2d spin lattice. */

int main(int argc, char** argv) {
   int        n,     nsteps;
   int        ltrace = 1;
   double     vpar[1];
   double    *a;
   int        j,     npar = 1;
   if( argc != 3 || sscanf(argv[1],"%d",&n) !=1 ||
                    sscanf(argv[2],"%d",&nsteps) != 1 ) goto Usage;
   if( ltrace ) {
      fprintf(stderr,"Tlat2d: n: %d  nsteps: %d\n",n,nsteps);
   }

   if( !(a = (double *) malloc(n*n*sizeof(double)) ) ) {
      fprintf(stderr,"Tlat2d: Could not allocate %d doubles\n",n*n);
      exit(1);
   }
   for( j = 0; j < nsteps; j++ ) {
      dmrandspin_(a,&n,&n);
      grlat2d(a,n,n,vpar,npar);
   }
   grlat2d(a,-n,-n,vpar,npar);

   exit(0);
Usage:
   fprintf(stderr,"usage: Tlat2d <n> <nsteps>\n");
   exit(1);
}
