/* Test driver for 'fsleep' ... */

#include <stdio.h>
#include "fsleep.h"

void usage(char *pgname) {
   fprintf(stderr,"usage: %s <freq> <nsecs>\n",pgname);
   exit(1);
}

main(int argc,char **argv) {
   int     freq,    nsecs,    i;
   float   sleep_interval;

   if( argc != 3 ) usage(argv[0]);
   if( (sscanf(argv[1],"%d",&freq) != 1) ) usage(argv[0]);
   if( (sscanf(argv[2],"%d",&nsecs) != 1) ) usage(argv[0]);
   fprintf(stderr,
           "%s: Will attempt to output %d times/sec for %d secs\n",
           argv[0],freq,nsecs);
   sleep_interval = 1.0 / (float) freq;
   for( i = 0; i < freq*nsecs; i++ ) {
      fsleep(sleep_interval);
      printf("Tick %d\n",i);
   }
}
